// Vorosweep - Copyright (C) 2010-2014 T. Mouton
//
// See the LICENSE.txt file for license information. Please report all
// bugs and problems to <thibaud.mouton@gmail.com>.

#include "common.h"
#include "border.h"

#ifndef _DOMAIN_INCLUDE
#define _DOMAIN_INCLUDE

namespace vorosweep
{
  
class Domain
{
  private:

    Point **p;
    int nbpt;
    Border **bo;
    int nbseg;

  public:
    Domain ( const char *filename );
    ~Domain();

    inline int point_size()
    {
      return nbpt;
    }
    inline int segment_size()
    {
      return nbseg;
    }
    inline Point *get_point ( int i )
    {
      return p[i];
    }
    inline Border *get_border ( int i )
    {
      return bo[i];
    }
    bool point_in_domain ( double *pt );
    void export_vtk ( );

};

};

#endif
