// Vorosweep - Copyright (C) 2010-2014 T. Mouton
//
// See the LICENSE.txt file for license information. Please report all
// bugs and problems to <thibaud.mouton@gmail.com>.

#include "vorosweep.h"

using namespace vorosweep;

void Graph::handle_newfacetswitch ( Event *ev )
{
  SweepFacet *sf = ev->get_sweepfacet();
  if ( sf->is_stopped() )
    return;
  double *pos = ev->get_coord();
  double time = ev->get_time();
//   int gid = ev->get_gid();
  std::vector<int> gid;

  Point *apex0 = sf->get_initial_sweepedge ( 0 )->get_start();
  Point *apex1 = sf->get_initial_sweepedge ( 1 )->get_start();

  if ( apex0 != apex1 )
  {
    bucketgrid->compute_crossed_bucket ( apex0->p, apex1->p, gid );
// 		for (int i = 0; i < gid.size(); i++)
// 		{
// 			printf("crossing cell %d\n", gid[i]);
// 		}
  }
  else
  {
    gid.push_back ( bucketgrid->get_index ( apex0->p ) );
  }

//   if ( gid == -1 ) // no need to set the facet stopped
//     return;

  for ( int i = 0; i < ( int ) gid.size(); i++ )
  {
    if ( gid[i] != -1 )
    {
      // add mc to the newly entered cell
      dbgprintf ( 5, "--> inserting facet in cell %d\n", gid[i] );
      bucketgrid->insert_sweepfacet ( sf, gid[i] );
      // compute next facet switch events
      Event *eventlist[MAX_EVENT_LIST];
      int nbe = 0;
      next_facetswitch ( sf, pos, gid[i], eventlist, nbe );
      dbgprintf ( 5, "--> listing %d next facet switch events :\n", nbe );
      for ( int j = 0; j < nbe; j++ )
      {
        Event *next = eventlist[j];
        dbgprintf ( 5, "--> next switch event add :\n" );
        add_event ( next );
      }
      // check for potential crash events in cell gid
      process_facet_events ( sf, time, gid[i] );
    }
  }
//   if (gid.size() > 1)
// 		getchar();
}
