// Vorosweep - Copyright (C) 2010-2014 T. Mouton
//
// See the LICENSE.txt file for license information. Please report all
// bugs and problems to <thibaud.mouton@gmail.com>.

#include "parameters.h"

using namespace vorosweep;

Parameters *Parameters::p = NULL;

Parameters::Parameters()
{
	grid.epsilon = 1e-16;
	grid.enlarge = 0.02;
	
	sweepobject.epsilon = 1e-16;
	sweepobject.horizontal = 1e-12;
	
	front.epsilon = 1e-16; // for point in segment test
	
	vorosweep.epsilon = 1e-14;
	vorosweep.coincident = 1e-16;
	
	vorosweep.read_borders = 0;
	vorosweep.perturb_borders = 1;
	vorosweep.perturb_angles = 0;
	vorosweep.dump = 0;
	vorosweep.depmod = 10;
	vorosweep.dumptime[0] = 10.0;
	vorosweep.dumptime[1] = 10.3;
	vorosweep.dumprate = 0.05;	
	vorosweep.multicrash = 1;
	
	generator.order = 2;
	
	output.draw_size = 0.8;
	output.draw_edges = 0;
	output.draw_iso = 1;
	output.isogap = 0.02;
	output.nbiso = 10;
	output.clip = 0;
	output.min[0] = 0.2;
	output.min[1] = 0.6;
	output.max[0] = 0.1;
	output.max[1] = 0.1;
	
	// verbosity
	debug = 0;
}

Parameters::~Parameters()
{
}

Parameters *Parameters::instance()
{
  return p;
}

void Parameters::initialize()
{
  if ( !p )
    p = new Parameters();
}
