// Vorosweep - Copyright (C) 2010-2014 T. Mouton
//
// See the LICENSE.txt file for license information. Please report all
// bugs and problems to <thibaud.mouton@gmail.com>.

#include "common.h"

#ifndef _PARAMETERS_INCLUDE
#define _PARAMETERS_INCLUDE

namespace vorosweep
{
class Parameters
{
private:
  static Parameters *p;
public:
  class gridparam
  {
  public:
    double epsilon;
    double enlarge;
  };
  class sweepparam
  {
  public:
    double epsilon;
		double horizontal;
  };
  class frontparam
  {
  public:
    double epsilon;
  };
  class voroparam
  {
  public:
		int read_borders;
		double epsilon;
		double coincident;
		int perturb_borders;
		int perturb_angles;
		int dump;
		int depmod;
		double dumptime[2];
		double dumprate;
		int multicrash;
  };
	class genparam
  {
  public:
		double order;
  };
	class outparam
  {
  public:
		double draw_size;
		int draw_edges;
		int draw_iso;
		double isogap;
		int nbiso;
		int clip;
		double min[2];
		double max[2];
  };
  gridparam grid;
  sweepparam sweepobject;
  frontparam front;
  voroparam vorosweep;
	genparam generator;
	outparam output;
	int debug;
public:
  Parameters();
  ~Parameters();
	static void initialize();
  static Parameters *instance();
	
};

};

#endif
