// Vorosweep - Copyright (C) 2010-2014 T. Mouton
//
// See the LICENSE.txt file for license information. Please report all
// bugs and problems to <thibaud.mouton@gmail.com>.

#include "common.h"
#include <geom.h>

#ifndef _PREDICATES_INCLUDE
#define _PREDICATES_INCLUDE

namespace vorosweep
{

namespace predicate
{
inline bool is_horizontal ( double *ndir )
{
  dbgprintf ( 2, "new dir --> %lf %lf %lf\n", ndir[0], ndir[1], ndir[2] );
  if ( fabs ( ndir[2] ) < Parameters::instance()->sweepobject.horizontal )
// 	if (  ndir[2] >= 0.0 &&  ndir[2] < Parameters::instance()->sweepobject.horizontal )
  {
    dbgprintf ( 2, "--> horizontal dir\n" );
    ndir[2] = 0.0;
    return true;
  }
  return false;
}

inline bool null_length ( double *ndir )
{
// 		printf ( "--> %lf %lf %.20lf\n", ndir[i][0], ndir[i][1], ndir[i][2] );
	if (  geom::sqrnorm2d ( ndir ) < Parameters::instance()->vorosweep.epsilon )
  {
    dbgprintf ( 2, "--> null length\n" );
    return true;
  }
  return false;
}

inline bool coincident ( double *pt0, double *pt1 )
{
  double dist = geom::sqrtdistance2d ( pt0, pt1 );
//   printf ( "dist --> %.20lf < %.20lf\n", dist, Parameters::instance()->vorosweep.coincident);
  if ( dist < Parameters::instance()->vorosweep.coincident )
  {
    return true;
  }
  return false;
}
};
};

#endif
